#include "DSin.h"
#include <iostream>

using namespace std; 


DSin::DSin(void)
{ 
	dir=0;
	devname=strdup("plug:dsnoop");
	rate=8000;
	sizeinbyte=160;
	num_channels=1;
	frames=sizeinbyte;
	periods=2;
	stream_in=SND_PCM_STREAM_CAPTURE;
}


DSin::~DSin(void)
{
	snd_pcm_drain(pcm_handle_in);
	//snd_pcm_drop(pcm_handle_in);
}


int DSin::rec(unsigned char *Data)
{
//	cout << "DSin: REC to local buffer --- " ;
 while(snd_pcm_readi(pcm_handle_in,Data,frames)<0)
 {//cout << "recording audio" << endl;
  snd_pcm_prepare(pcm_handle_in);}
  return sizeinbyte;

}

void DSin::loop_rec(unsigned char *Data) {
	while (1)
		rec(Data);
}

void DSin::set_parameters(void)
{	
	int err;
	if((err = snd_pcm_hw_params_malloc(&hwparams))){
			fprintf (stderr, "cannot allocate hardware parameter structure (%s)\n", 
				 snd_strerror (err));
			exit (1);
		}
	
	if((err = snd_pcm_open(&pcm_handle_in, devname, stream_in , 0)) < 0){
			fprintf (stderr, "cannot open audio device %s (%s)\n", 
				 devname,
				 snd_strerror (err));
			exit (1);
		}
	if((err = snd_pcm_hw_params_any(pcm_handle_in,hwparams)) < 0){
			fprintf (stderr, "cannot initialize hardware parameter structure (%s)\n", 
				 snd_strerror (err));
			exit (1);
		}
	if((err = snd_pcm_hw_params_set_access(pcm_handle_in,hwparams,SND_PCM_ACCESS_RW_INTERLEAVED)) < 0){
			fprintf (stderr, "cannot set access type (%s)\n", 
				 snd_strerror (err));
			exit (1);
		}
	if((err = snd_pcm_hw_params_set_format(pcm_handle_in,hwparams,SND_PCM_FORMAT_MU_LAW)) < 0){
			fprintf (stderr, "cannot set sample format (%s)\n", 
				 snd_strerror (err));
			exit (1);
		};
	if((err = snd_pcm_hw_params_set_rate_near(pcm_handle_in,hwparams,&rate,&dir) < 0)){
			fprintf (stderr, "cannot set sample rate (%s)\n", 
				 snd_strerror (err));
			exit (1);
		};
	if((err = snd_pcm_hw_params_set_channels(pcm_handle_in,hwparams,num_channels) < 0)){
			fprintf (stderr, "cannot set channel count (%s)\n", 
				 snd_strerror (err));
			exit (1);
		}
	if((err = snd_pcm_hw_params_set_period_size_near(pcm_handle_in,hwparams,&periods,&dir)) < 0){
			fprintf (stderr, "cannot set sample format (%s)\n", 
				 snd_strerror (err));
			exit (1);
		}
	if((err = snd_pcm_hw_params(pcm_handle_in, hwparams) < 0)){
			fprintf (stderr, "cannot set parameters (%s)\n", 
				 snd_strerror (err));
			exit (1);
		}
	snd_pcm_hw_params_free(hwparams);
}



