
#include "DStones.h"
#include <iostream>

using namespace std;

DStones::DStones(void)
{
 stream=SND_PCM_STREAM_PLAYBACK;
 periods=2;
 //devname = strdup("plughw:0,0");
 devname = strdup("plug:dmix");
 rate=8000;
 dir=0;
 num_channels=1;
 frames=4096;
}

void DStones::set_device(void)
{
 snd_pcm_open(&pcm_handle,devname,stream,0);
 snd_pcm_hw_params_malloc(&hwparams);
 snd_pcm_hw_params_any(pcm_handle,hwparams);
 snd_pcm_hw_params_set_access(pcm_handle,hwparams,SND_PCM_ACCESS_RW_INTERLEAVED);
 snd_pcm_hw_params_set_format(pcm_handle,hwparams,SND_PCM_FORMAT_S16_LE);
 snd_pcm_hw_params_set_channels(pcm_handle,hwparams,num_channels);
 snd_pcm_hw_params_set_rate_near(pcm_handle,hwparams,&rate,&dir);
 snd_pcm_hw_params_set_period_size_near(pcm_handle,hwparams,&periods,&dir);
 snd_pcm_hw_params(pcm_handle, hwparams);
 
 snd_pcm_uframes_t chunk_size, buffer_size;
 int DIR=0;
 snd_pcm_hw_params_get_period_size( hwparams, &chunk_size, &DIR );
 snd_pcm_hw_params_get_buffer_size( hwparams, &buffer_size );
 // cout << "chunk and buffer sizes:" << chunk_size << "  " << buffer_size << endl;
 //audio_buf.resize( chunk_size*2 );
	if (chunk_size == buffer_size) {
		fprintf (stderr, "Can't use period equal to buffer size (%lu == %lu)", chunk_size, buffer_size);
		exit (1);
	}
 snd_pcm_hw_params_free(hwparams);
}

void DStones::play_tone(unsigned char*Data,char *path)
{
	
 p_file = fopen(path,"r");
 p_buffer=Data;
 for(j=0;j<(frames*2);j++) {
	fscanf(p_file,"%c",p_buffer);
	p_buffer++;
 }
 fclose(p_file);
 while(snd_pcm_writei(pcm_handle,Data,frames)<0) {
	snd_pcm_prepare(pcm_handle);
 }
 usleep(1000000);
}

DStones::~DStones(void)
{
 //fclose(p_file);
// snd_pcm_drain(pcm_handle);
}



