#ifndef  _QUEUE_T_H
#define  _QUEUE_T_H
#include <assert.h>

template <class payload>
class queue;

template <class payload>
class   elem {
        friend class queue<payload>;    
        elem<payload>*	next;
        payload* pack;
 
     public:
            elem<payload>(payload* p) {next=0; pack=p;}
        virtual   ~elem<payload>() {}
        };

template <class payload>   
class queue {
        elem<payload>*  last;
        int    npack; //number of elements in the queue
        int    len;   //maximum length of the queue, -1 for infinite
     public:
        payload* operator [] (int i) {
          return get_payload(i);
          } 
	queue(int LEN=-1) { last=0; npack=0; len=LEN; }
        virtual   ~queue() {}
        int       push(payload* p);
        payload*  pop();
        int       get_npack() { return npack; }
        int       get_len() { return len; }
        void      put_len(int LEN) { len=LEN; }
        payload*  head();
        payload*  get_payload(int);
        payload*  remove(int);        
};


template <class payload>
int    queue<payload>::push(payload* p) {
              if ((len==-1)||(npack<len)) {
                npack++;
                if (last!=0) {
                   elem<payload>* temp = last;
                   last= new elem<payload>(p);
                   last->next=temp->next;
                   temp->next=last;
                  }
                else {
                   last= new elem<payload>(p);
                   last->next=last;
                  }
                return 0;
              }
              else return -1;
             }

template <class payload>
payload* queue<payload>::pop() {
                assert(npack>0);
                npack--;
                payload* pck=0;
                if (last==last->next) {
                   pck=last->pack;
                   delete last;
                   last=0;
                  }
                else {
                   elem<payload>* temp=last->next;
                   last->next=temp->next;
                   pck=temp->pack;
                   delete temp;
                  }
                return pck;
              }

template <class payload>
payload* queue<payload>::head() {
  assert(npack>=0);
  if(npack==0) return 0;
  
  payload* pck=0;
  if (last==last->next) {
    pck=last->pack;
  }
  else
    pck=last->next->pack;

  return pck;
}

template <class payload>
payload*  queue<payload>::get_payload(int L) {
  assert(L>=0);
  assert(L<npack);
  elem<payload>* p=last->next;
  for(int i=0; i<L; i++) p=p->next;
  return p->pack;
}

template <class payload>
payload*  queue<payload>::remove(int L) {
  assert(L>=0 && L<npack);
  elem<payload>* p1=last;
  elem<payload>* p2=0;
   payload* pld = 0;
 
  if(last->next == last){
    pld = last->pack;
    delete last;
    last=0;
    npack=0;
  }
  else if(L==npack-1) {
    for(int i=0; i<L; i++) p1=p1->next;
    pld = last->pack;
    p1->next = last->next;
    delete last;
    last = p1;
    npack--;
  }
  else {
    for(int i=0; i<L; i++) p1=p1->next;
    p2=p1->next; 
    p1->next = p1->next->next;
    pld = p2->pack;
    delete p2;
    npack--;
  }  
  return pld;
}

#endif
