/***************************************************************************
 *   Copyright (C) 2005 by ,,,   *
 *   giuseppe@Euclide   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef USERAGENTWIN_H
#define USERAGENTWIN_H


#include "mainDlg.h"

#include "aboutdlg.h"
#include "uasettings.h"
#include "useragentsip.h"

using namespace resip;

struct RtpDtmfEvent;


class UserAgentWin : public mainDlg
{
public:
void set_active(int P);
void set_inactive(int P);
void set_mute(bool M);

private:
  Q_OBJECT

public:
  UserAgentWin(QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
  ~UserAgentWin();
  /*$PUBLIC_FUNCTIONS$*/
  Data& getRtpPort() {return mRtpPort;}
  Data& getPort() {return mPort;}
  int get_console() {return console_id;}
  int get_line() {return line_id;}
  bool isactive;
  void LoadConfig();
  void Registration();

public slots:
  /*$PUBLIC_SLOTS$*/
  virtual void          helpAbout();
  virtual void          helpContents();
  virtual void          helpIndex();
  virtual void          editFind();
  virtual void          editPaste();
  virtual void          editCopy();
  virtual void          editCut();
  virtual void          editRedo();
  virtual void          editUndo();
  virtual void          fileExit();
  virtual void          filePrint();
  virtual void          fileSaveAs();
  virtual void          fileSave();
  virtual void          fileOpen();
  virtual void          fileNew();
  // Slot per la gestione del tastierino numerico  
  virtual void 		SlotStar();
  virtual void 		SlotSharp();
  virtual void 		SlotZero();
  virtual void 		SlotNine();
  virtual void 		SlotEight();
  virtual void 		SlotSeven();
  virtual void		SlotSix();
  virtual void 		SlotFive();
  virtual void 		SlotFour();
  virtual void 		SlotThree();
  virtual void 		SlotTwo();
  virtual void 		SlotOne();
  virtual void 		SlotA();
  virtual void 		SlotB();
  virtual void 		SlotC();
  virtual void 		SlotD();
  virtual void 		SlotRegistration();
  virtual void 		SlotSettings();
  virtual void 		SlotCall();
  virtual void 		SlotHungup();
  virtual void 		SlotCancel();
  virtual void 		SlotAt();
  virtual void 		SlotDot();
    virtual void SlotHungup(int P);
    virtual void SlotConsole1();
    virtual void SlotConsole4();
    virtual void SlotConsole3();
    virtual void SlotConsole2();
    virtual void SlotLine4();
    virtual void SlotLine3();
    virtual void SlotLine2();
    virtual void SlotIP();
    virtual void SlotPorts();
    virtual void SlotLine1();
    virtual void SlotUserInfo();
    virtual void SlotLineInfo();
    virtual void SlotMute();


protected:
  /*$PROTECTED_FUNCTIONS$*/

protected slots:
  /*$PROTECTED_SLOTS$*/

private:

	UASettings *mUASet;
	UserAgentSip *mClient;
	NameAddr mAor;
	Data mPassword;
	Data mPort;
	Data mPxPort;
	Data mRtpPort;
	int set_dtmf(int d, RtpDtmfEvent *ev);
	int console_id;
	int line_id;
	int nac[3];
	int act[3];
	int mut[3];
};

#endif

