
#include "DSbuffer.h"

#include <iostream>
#include <assert.h>
using namespace std;


DSbuffer::DSbuffer(pthread_mutex_t* BM)
{
	assert(BM != NULL);	
	max_size = MAX_BUFFER_SIZE;
	buff_mutex = BM;
	size =0;
}

DSbuffer::DSbuffer(pthread_mutex_t* BM, int N, char* name)
{
	size =0;
	assert(BM != NULL);	
	max_size = MAX_BUFFER_SIZE;
	buff_mutex = BM;
	create(N, name);
}

void DSbuffer::create(int Sizebuffer, char* name)
{
	assert(name!=0);
	buffer_name = new char[80];
	strcpy(buffer_name,name);
	p_buffer = new char[Sizebuffer];
	memset(p_buffer,0,Sizebuffer);
	max_size = Sizebuffer;
}


DSbuffer::~DSbuffer(void)
{
 delete[] static_cast<char *>( p_buffer);
}

void DSbuffer::write(void* DATA, size_t SIZE) {
	pthread_mutex_lock(buff_mutex);
	assert(DATA!=NULL);
	if(size+SIZE<max_size) {
		//cout << "writinig in "<< buffer_name << " --> " << SIZE << " bytes" << endl;
		memcpy((char*)p_buffer+size, (char*) DATA, SIZE);
		size+=SIZE;
	} else if(size<max_size) {
		//cout << "writinig in " << buffer_name << " (partial overflow) --> " << max_size-size << " bytes" << endl;
		memcpy((char*)p_buffer+size, (char*) DATA, max_size-size);
		size=max_size;
	} else {
		//cout << "writinig in " << buffer_name << " (complete overflow) --> 0 bytes" << endl;
	}
	pthread_mutex_unlock(buff_mutex);
}

int DSbuffer::fetch(unsigned N_DATA, void* ptr) {
	pthread_mutex_lock(buff_mutex);
	int aaa = 0;
	if(size>=N_DATA) {
		//cout << "reading from " << buffer_name << " --> " << N_DATA << " bytes"<< endl;
		memcpy((char*) ptr, (char*) p_buffer, N_DATA);
		memmove((char*) p_buffer,(char*) p_buffer+N_DATA, size-N_DATA);
		size -= N_DATA;
		aaa = N_DATA;
	} else if(size>0) {
		//cout << "reading from "<< buffer_name << " few data --> " << size << " bytes"<< endl;
		memcpy((char*) ptr, (char*) p_buffer, size);
		aaa = size;
		size = 0;
	} else {
		//cout << "reading from " << buffer_name <<" no data --> 0 bytes"<< endl;
		memmove((char*) p_buffer+N_DATA,(char*) p_buffer, max_size-N_DATA);
	}
	pthread_mutex_unlock(buff_mutex);
	return aaa;
}

void DSbuffer::fill() {
	memset((char*) p_buffer, 0, max_size);
}
