
#include "DSout.h"
#include <iostream>

using namespace std;

void DSout::play(unsigned char *Data)
{
//	cout << " --- DSout: PLAY from local buffer" <<endl;
	while(snd_pcm_writei(pcm_handle_out,Data,frames)<0)
		{snd_pcm_prepare(pcm_handle_out);}
		
}

void DSout::loop_play(unsigned char *Data)
{
	//cout << "playing audio" << endl;
	while(1)
		play(Data);
	//cout << "stop playing audio" <<endl;
}


void DSout::set_parameters(void)
{	
	int err;
	
	//snd_pcm_open(&pcm_handle_out,devname,stream_out,SND_PCM_NONBLOCK);
	if ((err = snd_pcm_open (&pcm_handle_out, devname, stream_out,0)) < 0) {
			fprintf (stderr, "cannot open audio device %s (%s)\n", 
				 devname,
				 snd_strerror (err));
			exit (1);
		}
	//snd_pcm_hw_params_any(pcm_handle_out,hwparams);
	if ((err = snd_pcm_hw_params_malloc (&hwparams)) < 0) {
			fprintf (stderr, "cannot allocate hardware parameter structure (%s)\n",
				 snd_strerror (err));
			exit (1);
		}
	if ((err = snd_pcm_hw_params_any (pcm_handle_out, hwparams)) < 0) {
			fprintf (stderr, "cannot initialize hardware parameter structure (%s)\n",
				 snd_strerror (err));
			exit (1);
		}
	//snd_pcm_hw_params_set_access(pcm_handle_out,hwparams,SND_PCM_ACCESS_RW_INTERLEAVED);
	if ((err = snd_pcm_hw_params_set_access (pcm_handle_out,hwparams, SND_PCM_ACCESS_RW_INTERLEAVED)) < 0) {
			fprintf (stderr, "cannot set access type (%s)\n",
				 snd_strerror (err));
			exit (1);
		}
	//snd_pcm_hw_params_set_format(pcm_handle_out,hwparams,SND_PCM_FORMAT_S16_LE);
	if ((err = snd_pcm_hw_params_set_format (pcm_handle_out,hwparams, SND_PCM_FORMAT_MU_LAW )) < 0) {
			fprintf (stderr, "cannot set sample format (%s)\n",
				 snd_strerror (err));
			exit (1);
		}
	//snd_pcm_hw_params_set_rate_near(pcm_handle_out,hwparams,&rate,&dir);
	if ((err = snd_pcm_hw_params_set_rate_near (pcm_handle_out,hwparams, &rate, &dir)) < 0) {
			fprintf (stderr, "cannot set sample rate (%s)\n",
				 snd_strerror (err));
			exit (1);
		}
	//snd_pcm_hw_params_set_channels(pcm_handle_out,hwparams,num_channels);
	if ((err = snd_pcm_hw_params_set_channels (pcm_handle_out,hwparams,num_channels)) < 0) {
			fprintf (stderr, "cannot set channel count (%s)\n",
				 snd_strerror (err));
			exit (1);
		}
	//snd_pcm_hw_params_set_period_size_near(pcm_handle_out,hwparams,&periods,&dir);
	if ((err = snd_pcm_hw_params_set_period_size_near( pcm_handle_out,hwparams,&periods,&dir)) < 0) {
		fprintf (stderr, "cannot set sample format (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	//snd_pcm_hw_params(pcm_handle_out, hwparams);
	if ((err = snd_pcm_hw_params (pcm_handle_out, hwparams)) < 0) {
			fprintf (stderr, "cannot set parameters (%s)\n",
				 snd_strerror (err));
			exit (1);
		}
	snd_pcm_hw_params_free(hwparams);
}

DSout::DSout(void)
{
	devname=strdup("plug:dmix");
	//devname=strdup("plughw:0,0");
	
	rate=8000;
	sizeinbyte=160;
	num_channels=1;
	frames= sizeinbyte;
	periods=2;
	stream_out=SND_PCM_STREAM_PLAYBACK;
	dir=0;
}


DSout::~DSout(void)
{
//	snd_pcm_drain(pcm_handle_out);
	//snd_pcm_drop(pcm_handle_out);
}



