/***************************************************************************
 *   Copyright (C) 2005 by ,,,   *
 *   giuseppe@Euclide   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "uasettings.h"

#include <qlineedit.h>
#include <qsettings.h>
#include <qradiobutton.h>
#include <qspinbox.h>
#include <qcombobox.h>
#include <iostream>
//#include "useragentsip.h"

using namespace resip;
using namespace std;

UASettings::UASettings(QWidget* parent, const char* name, WFlags fl)
    : Settings(parent,name,fl)
{
//	assert(UAS!=0);
//	active_UA = UAS;
}

UASettings::~UASettings()
{}

/*$SPECIALIZATION$*/


/********  IMPOSTAZIONI UTENTE *****************/

QString UASettings::getDisplayName( void ) const
{	
  return lEDisplayName->text();
  
}


QString UASettings::getAuthUserName( void ) const
{
  return lEAuthUser->text();
	
}

QString UASettings::getRegDuration( void ) const
{
  return lERegDur->text();
}

QString UASettings::getPassword( void ) const
{
  return lEPassword->text();
}

QString UASettings::getPort( void ) const
{
  return lEPort->text();
}

QString UASettings::getPxPort( void ) const
{
  return lEProxy_2->text();
}

QString UASettings::getProxyDomain( void ) const
{
  return lEProxy->text();
}

QString UASettings::getOutProxy( void ) const
{
  return lEOutProxy->text();
}

/*
QString UASettings::getSettingsStunServer( void ) const
{
  return leStunServer->text();
}
*/

QString UASettings::getAutoreg( void ) const
{
	QString status;
	    if ( rBregistration->isChecked() )
	    {
	    status = "yes";
                return status;
	    }
                else return status = "no";
}

QString UASettings::getPtime( void ) const
{	
	return cBoxPtime->currentText();

}

QString UASettings::getDtmfDuration( void ) const
{	
	return sBoxDuration->text();

}

QString UASettings::getDtmfPause( void ) const
{	
	return sBoxPause->text();

}

QString UASettings::getDtmfVolume( void ) const
{	
	return sBoxVolume->text();

}

QString UASettings::getLogOutput( void ) const
{	
	return cBoxOutput->currentText();

}

QString UASettings::getLogLevel( void ) const
{	
	return cBoxLevel->currentText();

}

QString UASettings::getDtmfMode( void ) const
{	
	return cBoxDTMF->currentText();

}

void UASettings::SlotStoreSipConfig()
{
  QSettings settingsUA;

  //settingsUA.insertSearchPath( QSettings::Unix, "" );

  //Scrive sul file di configurazione i parametri utente
  settingsUA.writeEntry( "/IMAGESUserAgent/User Parameters/DisplayName", getDisplayName() );
  settingsUA.writeEntry( "/IMAGESUserAgent/User Parameters/AuthenticationUserName", getAuthUserName() );
  settingsUA.writeEntry( "/IMAGESUserAgent/User Parameters/RegistrationDuration", getRegDuration() );
  settingsUA.writeEntry( "/IMAGESUserAgent/User Parameters/Password", getPassword() );
  settingsUA.writeEntry( "/IMAGESUserAgent/User Parameters/Port", getPort() );

  //Scrive sul file di configurazione i parametri server
  settingsUA.writeEntry( "/IMAGESUserAgent/User Parameters/ProxyDomain", getProxyDomain() );
  settingsUA.writeEntry( "/IMAGESUserAgent/User Parameters/OutboundProxy", getOutProxy() );
  settingsUA.writeEntry( "/IMAGESUserAgent/User Parameters/AutoRegistration", getAutoreg() );
  settingsUA.writeEntry( "/IMAGESUserAgent/User Parameters/PxPort", getPxPort() );

  //Scrive sul file di configurazione i parametri audio
  settingsUA.writeEntry( "/IMAGESUserAgent/G711 Parameters/Ptime", getPtime() );

  // writing parameters of DTMF events
  settingsUA.writeEntry( "/IMAGESUserAgent/DTMF Parameters/Mode", cBoxDTMF->currentItem() );
  settingsUA.writeEntry( "/IMAGESUserAgent/DTMF Parameters/Duration", getDtmfDuration() );
  settingsUA.writeEntry( "/IMAGESUserAgent/DTMF Parameters/Pause", getDtmfPause() );
  settingsUA.writeEntry( "/IMAGESUserAgent/DTMF Parameters/Volume", getDtmfVolume() );
  

  // Writing log options
  settingsUA.writeEntry( "/IMAGESUserAgent/Log Options/Output", cBoxOutput->currentItem()  );
  settingsUA.writeEntry( "/IMAGESUserAgent/Log Options/Level", cBoxLevel->currentItem() );

//active_UAS->setPort(getPort());
}

void UASettings::LoadConfig()
{

	QSettings settingsUA;
	
	// carica le impostazioni utente
	lEDisplayName ->setText(settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/DisplayName", "" ));
	lEAuthUser->setText(settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/AuthenticationUserName", "" ));
	if(settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/RegistrationDuration", "") == "")
		lERegDur->setText(settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/RegistrationDuration", "3600" ));
	else
		lERegDur->setText(settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/RegistrationDuration", "" ));
	lEPassword->setText(settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/Password", "" ));
	if (settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/Port", "") == "")
		lEPort->setText(settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/Port", "5060" ));
	else	
		lEPort->setText(settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/Port", "" ));
	lEProxy->setText(settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/ProxyDomain", "" ));
	lEOutProxy->setText(settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/OutboundProxy", "" ));
	if (settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/AutoRegistration", "") == "yes")
		rBregistration->setChecked( true );
	else	
		rBregistration->setChecked( false );
	if (settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/PxPort", "") == "")
		lEProxy_2->setText(settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/PxPort", "5060" ));
	else	
		lEProxy_2->setText(settingsUA.readEntry( "/IMAGESUserAgent/User Parameters/PxPort", "" ));
	//if (settingsUA.readEntry("/IMAGESUserAgent/Parametri G711/Ptime", "") == "")
	cBoxPtime->setCurrentText(settingsUA.readEntry("/IMAGESUserAgent/G711 Parameters/Ptime", "20"));
	
	// Loadinf Of DTMF parameters
	cBoxDTMF->setCurrentItem(atoi(settingsUA.readEntry("/IMAGESUserAgent/DTMF Parameters/Mode", "")));
	sBoxDuration->setValue( atoi(settingsUA.readEntry("/IMAGESUserAgent/DTMF Parameters/Duration", "")));
	sBoxPause->setValue( atoi(settingsUA.readEntry("/IMAGESUserAgent/DTMF Parameters/Pause", "")));	
	sBoxVolume->setValue( atoi(settingsUA.readEntry("/IMAGESUserAgent/DTMF Parameters/Volume", "")));
	
	cBoxDTMF->setCurrentItem(atoi(settingsUA.readEntry("/IMAGESUserAgent/Log Options/Output", "")));
	cBoxDTMF->setCurrentItem(atoi(settingsUA.readEntry("/IMAGESUserAgent/Log Options/Level", "")));
	
	/*  leStunServer->setText(settingsUA.readEntry( "/IMAGESUserAgent/Parameters server/StunServer", "" ));
  
// carica le impostazioni audio
QString audioCtrl;

audioCtrl = settingsUA.readEntry( "/IMAGESUserAgent/audio Parameters/CodecG711u", "");
if (audioCtrl == "no")
{
    audioCtrl = settingsUA.readEntry( "/IMAGESUserAgent/audio Parameters/CodecG711a", "");
    if ( audioCtrl == "no" )
	  {
		audioCtrl = settingsUA.readEntry( "/IMAGESUserAgent/audio Parameters/CodecGSM", "");                         if ( audioCtrl == "no" )
        rbAudioCodeciLBC->setChecked( true );
      else rbAudioCodecGsm->setChecked( true );
    }
    else  rbAudioCodecG711a->setChecked( true );
  }
  else rbAudioCodecG711u->setChecked( true );


  QString ringCtrl;
  ringCtrl = settingsUA.readEntry( "/IMAGESUserAgent/audio Parameters/Tono abilitato", "" );
  if( ringCtrl == "yes")
    rbRingYes->setChecked( true );
  else rbRingNo->setChecked( true );

  //carica le impostazioni video
  QString videoCtrl;
  videoCtrl =  settingsUA.readEntry( "/IMAGESUserAgent/video Parameters/CodecH261", "");
  if (videoCtrl == "yes")
    rbVideoCodecH261->setChecked( true );
  else rbVideoCodecH263->setChecked( true );
*/

}

void UASettings::SlotRegistration()
{
	
	QString user;
	NameAddr Aor;
	Data password;
	int port;
	string strUri;

	Aor.displayName() = Data( (const char*)getDisplayName() );
	strUri = "sip:";
        strUri = strUri + (const char*)( getAuthUserName() + '@' + getProxyDomain());
       
	Aor.uri() = Uri(strUri.c_str());
	cout << "Sto effettuando la registrazione per: " << strUri << endl;
		
	password = Data((const char *)getPassword());
	port = 5060;
	/*
        UserAgentSip *clientReg;
        clientReg = new UserAgentSip(Aor , password);
        clientReg->registartionSetup();*/
}








#include "uasettings.moc"

