/***************************************************************************
 *   Copyright (C) 2005 by ,,,   *
 *   giuseppe@Euclide   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "useragentwin.h"
#include <qlineedit.h>
#include <qlabel.h>
#include <qtextedit.h>
#include <qradiobutton.h>
#include <kled.h>
#include <qpushbutton.h>
#include <qdatetime.h>
#include <iostream>
#include "ctrlcenter.h"
#include "rtp_handler.h"

using namespace resip;
using namespace std;

void *BandFunction(void *ptr)
{
	UserAgentWin* Win = (UserAgentWin*) ptr;
	QTime timer;
	timer.start();
	int t;
	double b;
	double alpha = 0.5;
	while(Win->isactive) {
		usleep(2000000-1000*timer.elapsed());
		t=timer.restart();

		sscanf(Win->leRXband->text(),"%lf",&b);
		Win->leRXband->clear();
		if(b==0.0)
			Win->leRXband->insert(Data(8.0*SoftState.get_neat_rx_bytes()/t).c_str());
		else if (SoftState.get_neat_rx_bytes()==0.0)
			Win->leRXband->insert("0.0");
		else 
			Win->leRXband->insert(Data(alpha*b+(1.0-alpha)*8.0*SoftState.get_neat_rx_bytes()/t).c_str());

		sscanf(Win->leRXband_2->text(),"%lf",&b);
		Win->leRXband_2->clear();
		if(b==0.0)
			Win->leRXband_2->insert(Data(8.0*SoftState.get_gross_rx_bytes()/t).c_str());
		else if (SoftState.get_gross_rx_bytes()==0.0)
			Win->leRXband_2->insert("0.0");
		else 
			Win->leRXband_2->insert(Data(alpha*b+(1.0-alpha)*8.0*SoftState.get_gross_rx_bytes()/t).c_str());

		sscanf(Win->leTXband->text(),"%lf",&b);
		Win->leTXband->clear();
		if(b==0.0)
			Win->leTXband->insert(Data(8.0*SoftState.get_neat_tx_bytes()/t).c_str());
		else if (SoftState.get_neat_tx_bytes()==0.0)
			Win->leTXband->insert("0.0");
		else 
			Win->leTXband->insert(Data(alpha*b+(1.0-alpha)*8.0*SoftState.get_neat_tx_bytes()/t).c_str());

		sscanf(Win->leTXband_2->text(),"%lf",&b);
		Win->leTXband_2->clear();
		if(b==0.0)
			Win->leTXband_2->insert(Data(8.0*SoftState.get_gross_tx_bytes()/t).c_str());
		else if (SoftState.get_gross_tx_bytes()==0.0)
			Win->leTXband_2->insert("0.0");
		else 
			Win->leTXband_2->insert(Data(alpha*b+(1.0-alpha)*8.0*SoftState.get_gross_tx_bytes()/t).c_str());

		SoftState.set_rx_bytes(0.0, 0.0);
		SoftState.set_tx_bytes(0.0, 0.0);
	}
	return NULL;
}

UserAgentWin::UserAgentWin(QWidget* parent, const char* name, WFlags fl):
			 mainDlg(parent,name,fl)
{
	mUASet= new UASettings();
	mUASet->LoadConfig();
	string strUri;

	Log::Level lv;
	Log::Type lt;
	lv = Log::toLevel(Data((const char*)(mUASet->getLogLevel())));
	lt = Log::toType(Data((const char*)( mUASet->getLogOutput())));
	Log::initialize(lt,lv, "TTI_SUA v 4.2", "siplog");

	mAor.displayName() = Data( (const char*)mUASet->getDisplayName() );
	strUri = "sip:";
        strUri = strUri + (const char*)( mUASet->getAuthUserName() + '@' + mUASet->getProxyDomain());
	mAor.uri() = Uri(strUri.c_str());
	mPassword = Data((const char *)mUASet->getPassword());
	mPort = Data((const char *)mUASet->getPort());
	mPxPort = Data((const char *)mUASet->getPxPort());
	//DebugLog(<< "Inizializzazione UserAgentSip");
	mClient = new UserAgentSip(mAor , mPassword, (const char*)mUASet->getPtime(),mPort);
	mPort = Data(mClient->getPort()); //note: mPort could be changed
	mRtpPort = Data(mClient->getRtpPort());
	line_id=1;
	console_id=1;
	act[0] = 170;
	act[1] = 255;
	act[2] = 127;
	nac[0] = 255;
	nac[1] = 85;
	nac[2] = 127;
	mut[0] = 255;
	mut[1] = 255;
	mut[2] = 127;
	isactive=true;
	CCThread band_thread(&SoftState, BandFunction, this);
	band_thread.run();
}

UserAgentWin::~UserAgentWin()
{
	isactive=false;
}

int UserAgentWin::set_dtmf(int digit, RtpDtmfEvent *ev){
	DtmfEvent d = (DtmfEvent) digit;
	ev->digit = d;
	ev->duration = mUASet->getDtmfDuration().toInt();
	ev->pause = mUASet->getDtmfPause().toInt();
	ev->volume = mUASet->getDtmfVolume().toInt();
	cout << "\nsetting dtmf";
	cout << "\n duration = " << ev->duration;
	cout << "\n digit = " << ev->digit;	
	cout << "\n pause = " << ev->pause;
	cout << "\n volume = " << ev->volume << endl;
	return d;
}

/*$SPECIALIZATION$*/
void UserAgentWin::helpAbout()
{
    aboutDlg aBdlg( this);
    aBdlg.exec();
}

void UserAgentWin::helpContents()
{}

void UserAgentWin::helpIndex()
{}

void UserAgentWin::editFind()
{}

void UserAgentWin::editPaste()
{}

void UserAgentWin::editCopy()
{}

void UserAgentWin::editCut()
{}

void UserAgentWin::editRedo()
{}

void UserAgentWin::editUndo()
{}

void UserAgentWin::fileExit()
{}

void UserAgentWin::filePrint()
{}

void UserAgentWin::fileSaveAs()
{}

void UserAgentWin::fileSave()
{}

void UserAgentWin::fileOpen()
{}

void UserAgentWin::fileNew()
{}

void UserAgentWin::SlotZero()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");
			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event 0 (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigit0,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('0',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event 0 in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('0',1120);
				SP->ARX->dtmf_sent('0',1120);
			}
			return;
		}
	}
	else
		leSipUri->insert("0");
}

void UserAgentWin::SlotOne()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");

			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event 1 (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigit1,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('1',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event 1 in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('1',1120);
				SP->ARX->dtmf_sent('1',1120);
			}
			return;
		}
	}
	else
		leSipUri->insert("1");
}

void UserAgentWin::SlotTwo()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");

			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event 2 (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigit2,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('2',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event 2 in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('2',1120);
				SP->ARX->dtmf_sent('2',1120);
			}
			return;
		}
	}
	else
		leSipUri->insert("2");
}

void UserAgentWin::SlotThree()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");
			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event 3 (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigit3,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('3',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event 3 in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('3',1120);
				SP->ARX->dtmf_sent('3',1120);
			}
			return;
		}
	}	else
		leSipUri->insert("3");
}

void UserAgentWin::SlotFour()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");
			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event 4 (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigit4,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('4',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event 4 in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('4',1120);
				SP->ARX->dtmf_sent('4',1120);
			}
			return;
		}
	}
	else
		leSipUri->insert("4");
}

void UserAgentWin::SlotFive()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");
			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event 5 (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigit5,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('5',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event 5 in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('5',1120);
				SP->ARX->dtmf_sent('5',1120);
			}
			return;
		}
	}
	else
		leSipUri->insert("5");
}

void UserAgentWin::SlotSix()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");
			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event 6 (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigit6,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('6',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event 6 in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('6',1120);
				SP->ARX->dtmf_sent('6',1120);
			}
			return;
		}
	}
	else
		leSipUri->insert("6");
}

void UserAgentWin::SlotSeven()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");

			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event 7 (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigit7,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('7',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event 7 in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('7',1120);
				SP->ARX->dtmf_sent('7',1120);
			}
			return;
		}
	}	else
		leSipUri->insert("7");
}

void UserAgentWin::SlotEight()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");
			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event 8 (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigit8,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('8',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event 8 in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('8',1120);
				SP->ARX->dtmf_sent('8',1120);
			}
			return;
		}
	}
	else
		leSipUri->insert("8");
}

void UserAgentWin::SlotNine()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");
			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event 9 (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigit9,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('9',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event 9 in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('9',1120);
				SP->ARX->dtmf_sent('9',1120);
			}
			return;
		}
	}	else
		leSipUri->insert("9");
}

void UserAgentWin::SlotA()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");
			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event A (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigitA,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('A',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event A in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('A',1120);
				SP->ARX->dtmf_sent('A',1120);
			}
			return;
		}
	}	else
		leSipUri->insert("A");
}

void UserAgentWin::SlotB()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");
			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event B (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigitB,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('B',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event B in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('B',1120);
				SP->ARX->dtmf_sent('B',1120);
			}
			return;
		}
	}
	else
		leSipUri->insert("B");
}

void UserAgentWin::SlotC()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");
			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event C (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigitC,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('C',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event C in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('C',1120);
				SP->ARX->dtmf_sent('C',1120);
			}
			return;
		}
	}
	else
		leSipUri->insert("C");
}

void UserAgentWin::SlotD()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");
			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event D (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigitD,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('D',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event D in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('D',1120);
				SP->ARX->dtmf_sent('D',1120);
			}
			return;
		}
	}
	else
		leSipUri->insert("D");
}

void UserAgentWin::SlotSharp()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");
			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event # (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigitsharp,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('#',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event # in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('#',1120);
				SP->ARX->dtmf_sent('#',1120);
			}
			return;
		}
	}
	else
		leSipUri->insert("#");
}

void UserAgentWin::SlotStar()
{
	SessionPar* SP = NULL;
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->pos_id == console_id)
			break;
		else SP = NULL;
	}
	if(SP != NULL) {
		if(SP->session_status == active) {
			bool dtmf_in_band = true;
			if(mUASet->getDtmfMode()=="In band")
				dtmf_in_band=true;
			else if(mUASet->getDtmfMode()=="RFC 2833")
				dtmf_in_band=false;
			else
				teDisplay->append("Unknown DTMF mode, assuming In Band");
			if(!dtmf_in_band) {
				teDisplay->append((char*)"  sending DTMF event * (line #" + (string)Data(console_id).c_str() +")");
				RtpDtmfEvent *ev = new RtpDtmfEvent;
				set_dtmf(DTMFdigitstar,ev);
				SP->ATX->send_dtmf(ev);
				SP->ARX->dtmf_sent('*',1120);
			}
			else {
				teDisplay->append((char*)"  sending DTMF event * in band (line #" + (string)Data(console_id).c_str() +")");
				SP->ATX->send_dtmf_in_band('*',1120);
				SP->ARX->dtmf_sent('*',1120);
			}
			return;
		}
	}	else
		leSipUri->insert("*");
}


void UserAgentWin::SlotRegistration( )
{
	LoadConfig();
	Registration();
}

void UserAgentWin::Registration() {
	kLedReg->setColor( QColor( 255,255, 0 ) );
	
	mAor.displayName() = Data( (const char*)mUASet->getDisplayName() );
	string strUri = (string)"sip:" +(const char*)(mUASet->getAuthUserName() + '@' + mUASet->getProxyDomain() + ':' + mPort.c_str());
	//mClient = (string)"sip:" +(const char*)(mUASet->getAuthUserName() + '@' + mClient->getHostaddress() + ':' + mPort.c_str());
	mAor.uri() = Uri(strUri.c_str());
	mPassword = Data((const char *)mUASet->getPassword());

	QTime t;
	bool timeout = false;
	QString user;
	NameAddr Aor;
	Data password;
	Data rDuration;
	Aor.displayName() = Data( (const char*)mUASet->getDisplayName() );
	if(mUASet->getAuthUserName()==""){
			teDisplay->append("  Insert a user name in settings window");
			return ;
	}
	else if((mUASet->getProxyDomain() == "")){
			teDisplay->append("  Insert a proxy domain in settings window");
			return ;
	}
	strUri = (string)"sip:" + (const char*)(mUASet->getAuthUserName() + '@' + mUASet->getProxyDomain()) + ':' + mPxPort.c_str();
       	Aor.uri() = Uri(strUri.c_str());
	password = Data((const char *)mUASet->getPassword());
	rDuration = Data((const char *)mUASet->getRegDuration());
 	if(SoftState.registered){
		mClient->registrationSetup(Aor, password, "0" );
		teDisplay->append("System Time: " + (QTime::currentTime()).toString("hh:mm:ss"));
		teDisplay->append("  User Deregistration...");
		}
	else{
		teDisplay->append("System Time: " + (QTime::currentTime()).toString("hh:mm:ss"));
		teDisplay->append(("  Registrating user: " + QString(strUri.c_str())));
		mClient->registrationSetup(Aor, password, rDuration);
	}
	// Start a timer for the registration procedure
	t.start();
	bool temp=SoftState.registered;
	while(t.elapsed() <= 2000 && SoftState.registered == temp)
	{
		if(t.elapsed() > 2000) {
			timeout = true;
			teDisplay->append("  Timeout elapsed");
		}
	}

	if(SoftState.registered) {
		kLedReg->setColor( QColor( 0, 255, 0 ) );
		teDisplay->append("  User registered");
		tLabelReg->setText( "<p align=\"center\">Registered</p>" );
		ButtonRegistration->setText("Deregistration");
	} else {
		kLedReg->setColor( QColor( 255, 0, 0 ) );
		teDisplay->append("  User not registered");
		tLabelReg->setText( "<p align=\"center\">Not Registered</p>" );
		ButtonRegistration->setText("Registration");
	}
}


void UserAgentWin::SlotSettings()
{
	mUASet->show();
	mUASet->LoadConfig();
}

void UserAgentWin::SlotCall()
{	
	SessionPar* SP = NULL;
	LoadConfig();
	
	if(SoftState.busytone[console_id] || SoftState.failtone[console_id]) {
		teDisplay->append("  Please hungup and retry");
		return;
	}
	bool flag;
	if(SoftState.busy) {
		flag = false;
		for(int k=1; flag==false && k<=SoftState.get_list()->get_npack(); k++) {
			SP = (*SoftState.get_list())[k-1];
			if(SP->pos_id==console_id && SP->session_status == invite_received) {
				teDisplay->append("  Call accepted on line" + (string)Data(console_id).c_str());
				mClient->setPtime((const char*)(mUASet->getPtime()));
				SP->session_status = active;
				flag = true;
				if(SP->pos_id==line_id)
				switch (SP->pos_id) {
					case 1:
						SlotLine1();
						break;
					case 2:
						SlotLine2();
						break;
					case 3:
						SlotLine3();
						break;
					case 4:
						SlotLine4();
						break;
					default:
						break;
				}
			}
		}
		if(!flag) {
			teDisplay->append("  Line not available");
			return;
		}
	}
	else {
		flag = false;
		for(int k=1; flag==false && k<=SoftState.get_list()->get_npack(); k++) {
			SP = (*SoftState.get_list())[k-1];
			if(SP->pos_id==console_id && SP->session_status == invite_received) {
				teDisplay->append("  Call accepted on line" + (string)Data(console_id).c_str());
				cout << "\nVDB --> Call accepted on line " << console_id << endl;
				mClient->setPtime((const char*)(mUASet->getPtime()));
				SP->session_status = active;
				flag = true;
				if(SP->pos_id==line_id)
				switch (SP->pos_id) {
					case 1:
						SlotLine1();
						break;
					case 2:
						SlotLine2();
						break;
					case 3:
						SlotLine3();
						break;
					case 4:
						SlotLine4();
						break;
					default:
						break;
				}
			}
		}		
		if(!flag) {	
			if(console_id==line_id)
				switch (line_id) {
					case 1: 
						SlotLine1();
						break;
					case 2: 
						SlotLine2();
						break;
					case 3: 
						SlotLine3();
						break;
					case 4:
						SlotLine4();
						break;
					default:
						break;
				}
			teDisplay->append("System Time: " + (QTime::currentTime()).toString("hh:mm:ss"));
			SoftState.new_outgoing_req(0);
			string strUri = "sip:" +  mUASet->getAuthUserName() + '@' + mUASet->getProxyDomain();
//			mAor.displayName() = Data( (const char*)mUASet->getDisplayName() );
			//mAor.uri() = Uri(strUri.c_str());
			//mPort = Data((const char *)mUASet->getPort());
			//mClient->setPort(mPort);

			string strTo;
			Uri toUri;
			strTo = "sip:";

			strTo = strTo + (const char*)(leSipUri->text());
			if(SoftState.registered){
				if(strTo.find('@') == string::npos) 	
					strTo = strTo + '@' + (const char*)(mUASet->getProxyDomain());
			}
			else if(strTo.find('@') == string::npos) {
				teDisplay->append("  URI not valid");
				return;
			}
			teDisplay->append("  [INVITE to: " + QString(strTo.c_str()) + ']');	
			toUri = Uri(strTo.c_str());
			mClient->outgoingCall(toUri, mUASet->getPtime());
		}
	}
}

void UserAgentWin::SlotHungup()
{	
	int N = SoftState.get_list()->get_npack();
	SessionPar* SP = NULL;
	bool flag = false;
	for(int k=1; flag==false && k<=N; k++) {
		SP = (*SoftState.get_list())[k-1];
		if(SP->pos_id==console_id) {
			mClient->endingCall(SP->id);
			switch (SP->pos_id) {
					case 1: 
						pbLine1->setPaletteBackgroundColor(QColor(nac[0],nac[1],nac[2]));
						break;
					case 2: 
						pbLine2->setPaletteBackgroundColor(QColor(nac[0],nac[1],nac[2]));
						break;
					case 3: 
						pbLine3->setPaletteBackgroundColor(QColor(nac[0],nac[1],nac[2]));
						break;
					case 4:
						pbLine4->setPaletteBackgroundColor(QColor(nac[0],nac[1],nac[2]));
						break;
					default:
						break;
				}
			flag = true;
		}
	}
	if(!flag)
		teDisplay->append("###");
	SoftState.stop_ringing(console_id);
	SoftState.stop_busytone(console_id);
	SoftState.stop_failtone(console_id);
}

void UserAgentWin::SlotHungup(int P)
{
	int temp = console_id;
	console_id = P;
	SlotHungup();
	console_id = temp;
}

void UserAgentWin::SlotDot()
{
	leSipUri->insert(".");
}

void UserAgentWin::SlotCancel()
{
	leSipUri->backspace();
}


void UserAgentWin::SlotAt()
{
	leSipUri->insert("@");
}

/*
void UserAgentWin::SlotLine()
{
	int new_line = leLine->text().toInt();
	int new_console = leConsole->text().toInt();
	int active_line = leActiveLine->text().toInt();
	int active_console = leActiveConsole->text().toInt();
	int N = SoftState.get_list()->get_npack();
	int L = SoftState.get_list()->get_len();
	leLine->clear();
	leConsole->clear();
	SessionPar* SP;
	if(N==0) {
		leActiveLine->clear();
		leActiveConsole->clear();
		leActiveLine->insert("0");
		leActiveConsole->insert("1");
		console_id=1;
	}
	else if(new_line>0 && new_line<=N){
		if (new_line!=active_line) {
			teDisplay->append("Switch to active line: " + (string)Data(new_line).c_str() + " of " +(string)Data(L).c_str());
			leActiveLine->clear();
			leActiveConsole->clear();
			leActiveLine->insert((string)Data(new_line).c_str());
			leActiveConsole->insert((string)Data(new_line).c_str());		
			console_id = new_line;
			for(int k=0; k<N; k++) {
				SP=(*SoftState.get_list())[k];
				if(k==console_id-1) {
					SP->mute=false;
					SP->ARX->mute(false);
					SP->ATX->mute(false);
				} else {
					SP->mute=true;
					SP->ARX->mute(true);
					SP->ATX->mute(true);
				}
			}
		} 
		else if(new_console!=active_console && new_console>0 && new_console<=L) {
			teDisplay->append("Switch to console: " + (string)Data(new_console).c_str() + " of " +(string)Data(L).c_str() + " (Line " + (string)Data(active_line).c_str() + " still active)");
			leActiveConsole->clear();
			leActiveConsole->insert((string)Data(new_console).c_str());
			if(new_console>N)
				teDisplay->append("  No connections on Line " + (string)Data(new_console).c_str());
			else 
				teDisplay->append("  Mute connection on Line " + (string)Data(new_console).c_str());
			console_id = new_console;
		}
	}
	else if(new_line>N && new_line<=L) {
		teDisplay->append("Switch to console: " + (string)Data(new_line).c_str() + " of " +(string)Data(L).c_str() + " (Line " + (string)Data(active_line).c_str() + " still active)");
		leActiveConsole->clear();
		leActiveConsole->insert((string)Data(new_line).c_str());
		teDisplay->append("  No connections on Line " + (string)Data(new_line).c_str());
		console_id = new_line;
	}
	else {
		teDisplay->append("Not valid line or console (use 1-" +(string)Data(L).c_str() + ")");
	}
}
*/

void UserAgentWin::SlotLine1()
{
	leActiveLine->clear();
	leActiveLine->insert("1");
	leActiveConsole->clear();
	leActiveConsole->insert("1");
	console_id=1;
	line_id=1;
	SessionPar* SP=NULL;
	int color[SoftState.get_list()->get_len()][3];
	for(int k=0; k<SoftState.get_list()->get_len(); k++) {
		color[k][0] = nac[0];
		color[k][1] = nac[1];
		color[k][2] = nac[2];
	}
	for(int k=0; k<SoftState.get_list()->get_npack(); k++) {
		SP=(*SoftState.get_list())[k];
		if(SP->pos_id==1) {
			SP->mute=false;
			if(SP->session_status==1 && SP->ARX != NULL && SP->ATX!= NULL) {
				cout<<"\nVDB --> line 1 active, going mute" << endl;
				SP->ARX->mute(false);
				SP->ATX->mute(false);
			}
			color[SP->pos_id-1][0] = act[0];
			color[SP->pos_id-1][1] = act[1];
			color[SP->pos_id-1][2] = act[2];
			pbMute->setText("Mute");
		}
		else {
			SP->mute=true;
			if(SP->session_status==1 && SP->ARX != NULL && SP->ATX!= NULL) {
				SP->ARX->mute(true);
				SP->ATX->mute(true);
			}
			if(SP->session_status!=idle) {
				color[SP->pos_id-1][0] = mut[0];
				color[SP->pos_id-1][1] = mut[1];
				color[SP->pos_id-1][2] = mut[2];
			}
			else {
				color[SP->pos_id-1][0] = nac[0];
				color[SP->pos_id-1][1] = nac[1];
				color[SP->pos_id-1][2] = nac[2];
			}
		}
	}
	pbLine1->setPaletteBackgroundColor(QColor(color[0][0],color[0][1],color[0][2]));
	pbLine2->setPaletteBackgroundColor(QColor(color[1][0],color[1][1],color[1][2]));
	pbLine3->setPaletteBackgroundColor(QColor(color[2][0],color[2][1],color[2][2]));
	pbLine4->setPaletteBackgroundColor(QColor(color[3][0],color[3][1],color[3][2]));
	pbConsole2->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
	pbConsole3->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
	pbConsole4->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
	pbConsole1->setPaletteBackgroundColor(QColor(act[0], act[1], act[2]));
}

void UserAgentWin::SlotLine2()
{
	leActiveLine->clear();
	leActiveLine->insert("2");
	leActiveConsole->clear();
	leActiveConsole->insert("2");
	console_id=2;
	line_id=2;
	SessionPar* SP = NULL;
	int color[SoftState.get_list()->get_len()][3];
	for(int k=0; k<SoftState.get_list()->get_len(); k++) {
		color[k][0] = nac[0];
		color[k][1] = nac[1];
		color[k][2] = nac[2];
	}
	for(int k=0; k<SoftState.get_list()->get_npack(); k++) {
		SP=(*SoftState.get_list())[k];
		if(SP->pos_id==2) {
			SP->mute=false;
			if(SP->session_status==1 && SP->ARX != NULL && SP->ATX!= NULL) {
				SP->ARX->mute(false);
				SP->ATX->mute(false);
			}
			color[SP->pos_id-1][0] = act[0];
			color[SP->pos_id-1][1] = act[1];
			color[SP->pos_id-1][2] = act[2];
			pbMute->setText("Mute");
		}
		else {
			SP->mute=true;
			if(SP->session_status==1 && SP->ARX != NULL && SP->ATX!= NULL) {
				SP->ARX->mute(true);
				SP->ATX->mute(true);
			}
			if(SP->session_status!=idle) {
				color[SP->pos_id-1][0] = mut[0];
				color[SP->pos_id-1][1] = mut[1];
				color[SP->pos_id-1][2] = mut[2];
			}
			else {
				color[SP->pos_id-1][0] = nac[0];
				color[SP->pos_id-1][1] = nac[1];
				color[SP->pos_id-1][2] = nac[2];
			}
		}
	}
	pbLine1->setPaletteBackgroundColor(QColor(color[0][0],color[0][1],color[0][2]));
	pbLine2->setPaletteBackgroundColor(QColor(color[1][0],color[1][1],color[1][2]));
	pbLine3->setPaletteBackgroundColor(QColor(color[2][0],color[2][1],color[2][2]));
	pbLine4->setPaletteBackgroundColor(QColor(color[3][0],color[3][1],color[3][2]));
	pbConsole1->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
	pbConsole3->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
	pbConsole4->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
	pbConsole2->setPaletteBackgroundColor(QColor(act[0], act[1], act[2]));
}

void UserAgentWin::SlotLine3()
{
	leActiveLine->clear();
	leActiveLine->insert("3");
	leActiveConsole->clear();
	leActiveConsole->insert("3");
	console_id=3;
	line_id=3;
	SessionPar* SP = NULL;
	int color[SoftState.get_list()->get_len()][3];
	for(int k=0; k<SoftState.get_list()->get_len(); k++) {
		color[k][0] = nac[0];
		color[k][1] = nac[1];
		color[k][2] = nac[2];
	}
	for(int k=0; k<SoftState.get_list()->get_npack(); k++) {
		SP=(*SoftState.get_list())[k];
		if(SP->pos_id==3) {
			SP->mute=false;
			if(SP->session_status==1 && SP->ARX != NULL && SP->ATX!= NULL) {
				SP->ARX->mute(false);
				SP->ATX->mute(false);
			}
			color[SP->pos_id-1][0] = act[0];
			color[SP->pos_id-1][1] = act[1];
			color[SP->pos_id-1][2] = act[2];
			pbMute->setText("Mute");
		}
		else {
			SP->mute=true;
			if(SP->session_status==1 && SP->ARX != NULL && SP->ATX!= NULL) {
				SP->ARX->mute(true);
				SP->ATX->mute(true);
			}
			if(SP->session_status!=idle) {
				color[SP->pos_id-1][0] = mut[0];
				color[SP->pos_id-1][1] = mut[1];
				color[SP->pos_id-1][2] = mut[2];
			}
			else {
				color[SP->pos_id-1][0] = nac[0];
				color[SP->pos_id-1][1] = nac[1];
				color[SP->pos_id-1][2] = nac[2];
			}
		}
	}
	pbLine1->setPaletteBackgroundColor(QColor(color[0][0],color[0][1],color[0][2]));
	pbLine2->setPaletteBackgroundColor(QColor(color[1][0],color[1][1],color[1][2]));
	pbLine3->setPaletteBackgroundColor(QColor(color[2][0],color[2][1],color[2][2]));
	pbLine4->setPaletteBackgroundColor(QColor(color[3][0],color[3][1],color[3][2]));
	pbConsole1->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
	pbConsole2->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
	pbConsole4->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
	pbConsole3->setPaletteBackgroundColor(QColor(act[0], act[1], act[2]));
}

void UserAgentWin::SlotLine4()
{
	leActiveLine->clear();
	leActiveLine->insert("4");
	leActiveConsole->clear();
	leActiveConsole->insert("4");
	console_id=4;
	line_id=4;
	SessionPar* SP = NULL;
	int color[SoftState.get_list()->get_len()][3];
	for(int k=0; k<SoftState.get_list()->get_len(); k++) {
		color[k][0] = nac[0];
		color[k][1] = nac[1];
		color[k][2] = nac[2];
	}
	for(int k=0; k<SoftState.get_list()->get_npack(); k++) {
		SP=(*SoftState.get_list())[k];
		if(SP->pos_id==4) {
			SP->mute=false;
			if(SP->session_status==1 && SP->ARX != NULL && SP->ATX!= NULL) {
				SP->ARX->mute(false);
				SP->ATX->mute(false);
			}
			color[SP->pos_id-1][0] = act[0];
			color[SP->pos_id-1][1] = act[1];
			color[SP->pos_id-1][2] = act[2];
			pbMute->setText("Mute");
		}
		else {
			SP->mute=true;
			if(SP->session_status==1 && SP->ARX != NULL && SP->ATX!= NULL) {
				SP->ARX->mute(true);
				SP->ATX->mute(true);
			}
			if(SP->session_status!=idle) {
				color[SP->pos_id-1][0] = mut[0];
				color[SP->pos_id-1][1] = mut[1];
				color[SP->pos_id-1][2] = mut[2];
			}
			else {
				color[SP->pos_id-1][0] = nac[0];
				color[SP->pos_id-1][1] = nac[1];
				color[SP->pos_id-1][2] = nac[2];
			}
		}
	}
	pbLine1->setPaletteBackgroundColor(QColor(color[0][0],color[0][1],color[0][2]));
	pbLine2->setPaletteBackgroundColor(QColor(color[1][0],color[1][1],color[1][2]));
	pbLine3->setPaletteBackgroundColor(QColor(color[2][0],color[2][1],color[2][2]));
	pbLine4->setPaletteBackgroundColor(QColor(color[3][0],color[3][1],color[3][2]));
	pbConsole1->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
	pbConsole2->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
	pbConsole3->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
	pbConsole4->setPaletteBackgroundColor(QColor(act[0], act[1], act[2]));
}

void UserAgentWin::SlotConsole1()
{
	leActiveConsole->clear();
	leActiveConsole->insert("1");
	console_id = 1;
	if(console_id==line_id)
		SlotLine1();
	else {
		pbConsole2->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
		pbConsole3->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
		pbConsole4->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
		pbConsole1->setPaletteBackgroundColor(QColor(act[0], act[1], act[2]));
	}
}

void UserAgentWin::SlotConsole2()
{	
	leActiveConsole->clear();
	leActiveConsole->insert("2");
	console_id = 2;
	if(console_id==line_id)
		SlotLine2();
	else {
		pbConsole1->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
		pbConsole3->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
		pbConsole4->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
		pbConsole2->setPaletteBackgroundColor(QColor(act[0], act[1], act[2]));
	}
}

void UserAgentWin::SlotConsole3()
{
	leActiveConsole->clear();
	leActiveConsole->insert("3");
	console_id = 3;
	if(console_id==line_id)
		SlotLine3();
	else {
		pbConsole1->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
		pbConsole2->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
		pbConsole4->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
		pbConsole3->setPaletteBackgroundColor(QColor(act[0], act[1], act[2]));
	}
}

void UserAgentWin::SlotConsole4()
{
	leActiveConsole->clear();
	leActiveConsole->insert("4");
	console_id = 4;
	if(console_id==line_id)
		SlotLine4();
	else {
		pbConsole1->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
		pbConsole2->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
		pbConsole3->setPaletteBackgroundColor(QColor(nac[0], nac[1], nac[2]));
		pbConsole4->setPaletteBackgroundColor(QColor(act[0], act[1], act[2]));
	}
}

void UserAgentWin::set_active(int P) {
	switch (P) {
		case 1:
			pbLine1->setPaletteBackgroundColor(QColor(mut[0],mut[1], mut[2]));
			break;
		case 2:
			pbLine2->setPaletteBackgroundColor(QColor(mut[0],mut[1], mut[2]));
			break;
		case 3:
			pbLine3->setPaletteBackgroundColor(QColor(mut[0],mut[1], mut[2]));
			break;
		case 4:
			pbLine4->setPaletteBackgroundColor(QColor(mut[0],mut[1], mut[2]));
			break;
		default :
			exit(-1);
 	 }
}


void UserAgentWin::set_inactive(int P) {
	switch (P) {
		case 1:
			pbLine1->setPaletteBackgroundColor(QColor(nac[0],nac[1], nac[2]));
			break;
		case 2:
			pbLine2->setPaletteBackgroundColor(QColor(nac[0],nac[1], nac[2]));
			break;
		case 3:
			pbLine3->setPaletteBackgroundColor(QColor(nac[0],nac[1], nac[2]));
			break;
		case 4:
			pbLine4->setPaletteBackgroundColor(QColor(nac[0],nac[1], nac[2]));
			break;
		default :
			exit(-1);
 	 }
}

void UserAgentWin::set_mute(bool M) {
	M?pbMute->setText("Unmute"):pbMute->setText("Mute");
}

void UserAgentWin::SlotMute()
{
	if(console_id != line_id)
		return;

	SessionPar* SP = NULL;
	int k = 0;
	for(; k<SoftState.get_list()->get_npack(); k++) {
		SP=(*SoftState.get_list())[k];
		if(SP->pos_id == console_id)
			break;
	}
	if(k<SoftState.get_list()->get_npack() && SP->session_status==1 && SP->ARX != NULL && SP->ATX!= NULL) {
		SP->mute = !(SP->mute);
		SP->ARX->mute(SP->mute);
		SP->ATX->mute(SP->mute);
		SP->mute?pbMute->setText("Unmute"):pbMute->setText("Mute");
	}
}

void UserAgentWin::SlotLineInfo() {
	char message[256];
	SessionPar* SP=NULL;
	teDisplay->append("Lines info:" );
	if(SoftState.get_list()->get_npack()==0) {
		teDisplay->append("  No connections in progress");
	}
	for(int j=0; j<SoftState.get_list()->get_npack(); j++) {
		SP=(*SoftState.get_list())[j];
		if(SP->mCis!=NULL) {
			sprintf(message,"    Line #%d with %s@%s:%d (local port: %d) status = %d (outgoing)", SP->pos_id, ((InviteSession*)(SP->mCis->get()))->peerAddr().uri().user().c_str(),SP->dest_IP.getHostname(), SP->dest_port, SP->source_port, SP->session_status);
		}
		else	if(SP->mSis!=NULL) {	
			sprintf(message,"    Line #%d with %s@%s:%d (local port: %d) status = %d (incoming)", SP->pos_id, ((InviteSession*)(SP->mSis->get()))->peerAddr().uri().user().c_str(),SP->dest_IP.getHostname(), SP->dest_port, SP->source_port, SP->session_status);
		} 
		else 
			sprintf(message,"    Line #%d not active", j+1);
		teDisplay->append(message);
	}
}

void UserAgentWin::SlotUserInfo() {
	char message[64];
	teDisplay->append("User info:" );
	sprintf(message,"    display name: %s", (const char*)mUASet->getDisplayName());
	teDisplay->append(message);
	sprintf(message,"    authentication user name: %s", (const char*)mUASet->getAuthUserName());
	teDisplay->append(message);
}

void UserAgentWin::SlotPorts() {
	char message[64];
	teDisplay->append("Local ports:");
	sprintf(message,"    Control: %s", mPort.data());
	teDisplay->append(message);
	sprintf(message,"    Data: >= %s", mRtpPort.data());
	teDisplay->append(message);
}

void UserAgentWin::SlotIP() {
	char message[64];
	teDisplay->append("Local IP:");
	sprintf(message,"    %s", mClient->get_IP().c_str());
	teDisplay->append(message);
}

void UserAgentWin::LoadConfig() {
	NameAddr mAor_old = mAor;
	Data mPassword_old = mPassword;
	Data mPort_old = mPort;
	Data mPxPort_old = mPxPort;

	mUASet->LoadConfig();
	mPassword = Data((const char *)mUASet->getPassword());
	mPort = Data((const char *)mUASet->getPort());
	mAor.displayName() = Data((const char*)mUASet->getDisplayName());
	string strUri = "sip:" + mUASet->getAuthUserName() + '@' + mUASet->getProxyDomain() + ':' + mPort.c_str();
	mAor.uri() = Uri(strUri.c_str());
	mClient->update(mAor , mPassword, (const char*)mUASet->getPtime(),mPort);

	if(SoftState.registered && (mAor_old.displayName()!=mAor.displayName() || mAor_old.uri()!=mAor.uri() || mPassword_old!=mPassword || mPort_old!=mPort || mPxPort_old!=mPxPort))
	{
		Registration();
		usleep(1000000);
		Registration();
	}
}

#include "useragentwin.moc"

